program SlotInfo;

uses
  krScramDisk,
  krSdStructures,
  SysUtils;

{$APPTYPE CONSOLE}

var
  n:Integer;
  Slot : TSlotInfo;
  CmdLineok:boolean;
  FirstCharOfCommandLine:char;

begin
  cmdlineOK:=false;

  if (paramcount = 0) then
  begin
    cmdlineOK:=true;
    WriteLn('ScramDisk - Slot Information');
    with TkrScramDisk.Create(nil) do
      try
        Active:=True;
        UpdateSlotInfo;
        For n:= 0 to 7 do
          begin
            Slot := GetSlotInfo(n);
            if Slot.MountType <>mtNotMounted then
              WriteLn(IntToStr(n) + ': ' + Slot.DriveMountedAs + ': ' + Slot.VolumeName+ ' ('+slot.CipherType+')')
            else
              WriteLn(IntToStr(n) + ': Empty');
          end;
      finally
        Free;
      end;
  end;

  if (paramcount = 1)and(length(paramstr(1))=1) then
  begin
    FirstCharOfCommandLine:= paramstr(1)[1];
    if FirstCharOfCommandLine in ['0'..'9'] then
    begin
      cmdlineOK:=true;
      WriteLn('ScramDisk - Detailed Slot Information');

      with TkrScramDisk.Create(nil) do
        try
          Active:=True;
          UpdateSlotInfo;
          Slot := GetSlotInfo(strtoint(FirstCharOfCommandLine));
          if Slot.MountType <> mtNotMounted then
          begin
            WriteLn('Slot number      :  '+IntToStr(n));
            writeln('Drive letter     :  '+Slot.DriveMountedAs);
            writeln('Volume name      :  '+Slot.VolumeName);
            writeln('Cipher           :  '+slot.CipherType);
            if slot.mounttype = mtPartition then
              writeln('Type             :  Partition');
            if slot.mounttype = mtSVLFile then
              writeln('Type             :  Container File');
            if slot.mounttype = mtWAVFile then
              writeln('Type             :  WAV File');
            if (slot.mounttype = mtWAVFile)or(slot.mounttype = mtSVLFile) then
              writeln('Container File   :  '+slot.FileName);
            writeln('Num Access       :  '+inttostr(Slot.NoAccesses));
            writeln('Last Access      :  '+datetimetostr(Slot.LastAccess));
          end
          else
            WriteLn('Slot Empty');
        finally
          Free;
        end;
    end;
  end;

  if not(cmdlineOK) then
  begin
    writeln('ScramDisk - Slot Info');
    writeln('');
    writeln('Slotinfo [SlotNum]');
    writeln('');
    writeln('  [SlotNum]    Specify a slot to give detailed information on');
    writeln('               Blank command line gives brief info on all slots');
    writeln('');
    writeln('Example: slotinfo 1');
    writeln('');
  end;
end.
